import * as Rx from 'rxjs';
import BigNumber from 'bignumber.js';
export interface SubscriptionOptions {
    symbol: string;
    prec?: 'P0' | 'P1' | 'P2' | 'P3' | 'P4';
    freq?: 'F0' | 'F1';
    length?: 25 | 100;
}
export declare type SubscriptionOptionsWithoutSymbol = Pick<SubscriptionOptions, Exclude<keyof SubscriptionOptions, 'symbol'>>;
export declare const book: <T>(options: SubscriptionOptions) => Rx.Observable<T | T[]>;
export interface TradingPairBookEntry {
    price: BigNumber;
    count: BigNumber;
    amount: BigNumber;
}
export declare const pair: (pair: string, options?: Pick<SubscriptionOptions, "prec" | "freq" | "length">) => Rx.Observable<TradingPairBookEntry | TradingPairBookEntry[]>;
export interface CurrencyBookEntry {
    rate: BigNumber;
    period: BigNumber;
    count: BigNumber;
    amount: BigNumber;
}
export declare const currency: (symbol: string, options?: Pick<SubscriptionOptions, "prec" | "freq" | "length">) => Rx.Observable<CurrencyBookEntry | CurrencyBookEntry[]>;
declare type TrackableBookEntry = CurrencyBookEntry | TradingPairBookEntry;
export declare const track: <T extends TrackableBookEntry>(initial?: T[]) => Rx.OperatorFunction<T | T[], T[]>;
export {};
